package dMartinez;

import gui.run.RunButton;

import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

/* ListDemo.java is a 1.4 application that requires no other files. */
public class ListDemo extends JPanel
                      implements ListSelectionListener {
    private JList list;
    private DefaultListModel listModel;

    private static final String addString = "Add";
    private static final String removeString = "Remove";
    private JButton removeButton;
    private JTextField employeeName;

    JDialog frame;

    StocksFrame sf = new StocksFrame();
    public ListDemo(final StocksFrame stockFrame){
          sf =stockFrame;
    }
    public ListDemo() {
        super(new BorderLayout());

       //I wanted to instruct the user how to use my GUI. So I added this test within my GUI.
        listModel = new DefaultListModel();
         listModel.addElement("PLEASE READ MESSAGE BELOW BEFORE YOU BEGIN.");
        listModel.addElement("This dialog box will be used to enter symbols.");
       listModel.addElement("Use the text field below to enter symbols");
         listModel.addElement("and then press the add button.");
         listModel.addElement("A message may follow your symbol...");
         listModel.addElement("please read it and follow instructions.");
         listModel.addElement("Before you begin: please press the reset button");





        //Create the list and put it in a scroll pane.
        list = new JList(listModel);

        list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.setSelectedIndex(0);
        list.addListSelectionListener(this);
        list.setVisibleRowCount(5);
        JScrollPane listScrollPane = new JScrollPane(list);

        JButton hireButton = new JButton(addString);
        AddListener hireListener = new AddListener(hireButton);
        hireButton.setActionCommand(addString);
        hireButton.addActionListener(hireListener);
        hireButton.setEnabled(false);

        removeButton = new JButton(removeString);
        removeButton.setActionCommand(removeString);
        removeButton.addActionListener(new RemoveListener());

        employeeName = new JTextField(10);
        employeeName.addActionListener(hireListener);
        employeeName.getDocument().addDocumentListener(hireListener);
        listModel.getElementAt(
                                      list.getSelectedIndex()).toString();

        //Create a panel that uses BoxLayout.
        JPanel buttonPane = new JPanel();
        buttonPane.setLayout(new BoxLayout(buttonPane,
                                           BoxLayout.LINE_AXIS));
        buttonPane.add(removeButton);
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(new JSeparator(SwingConstants.VERTICAL));
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(employeeName);
        buttonPane.add(hireButton);
        buttonPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));


       add(resetButton(),BorderLayout.WEST);
       add(getButton(),BorderLayout.EAST);
       add(listScrollPane, BorderLayout.CENTER);
       add(buttonPane, BorderLayout.PAGE_END);
    }
    //This is called when the Done! button is pushed.
    public void endListDemo(){
            super.getTopLevelAncestor().setEnabled(false);
           super.getTopLevelAncestor().setVisible(false);
    }
       //I added this button into the ListDemo GUI
       public JPanel resetButton() {
        JPanel buttonPanel = new JPanel();

           RunButton resetButton = new RunButton("Reset") {
               public void run() {

                   listModel.removeAllElements();

               }
           };


        buttonPanel.add(resetButton);
        return buttonPanel;
    }
    //this button is also added into the ListDemo GUI
    public JPanel getButton() {
        JPanel buttonPanel = new JPanel();

        RunButton okButton = new RunButton("DONE!") {

            public void run() {
                Vector newQuotes = new Vector();
                for (int x = 0; x < listModel.getSize(); x++) {
                    newQuotes.addElement(listModel.getElementAt(x).toString());

                }
                sf.setList(newQuotes);

                endListDemo();

            }
        };


        buttonPanel.add(okButton);
        return buttonPanel;
    }

    class RemoveListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            //This method can be called only if
            //there's a valid selection
            //so go ahead and remove whatever's selected.
            int index = list.getSelectedIndex();
            listModel.remove(index);

            int size = listModel.getSize();

            if (size == 0) { //Nobody's left, disable firing.
                removeButton.setEnabled(false);

            } else { //Select an index.
                if (index == listModel.getSize()) {
                    //removed item in last position
                    index--;
                }

                list.setSelectedIndex(index);
                list.ensureIndexIsVisible(index);
            }
        }
    }

    //This listener is shared by the text field and the hire button.
    class AddListener implements ActionListener, DocumentListener {


        
        private boolean alreadyEnabled = false;
        private JButton button;

        public AddListener(JButton button) {
            this.button = button;
        }

        //Required by ActionListener.
        public void actionPerformed(ActionEvent e) {
            String name = employeeName.getText();

            //User didn't type in a unique name...
            if (name.equals("") || alreadyInList(name)) {
                Toolkit.getDefaultToolkit().beep();
                employeeName.requestFocusInWindow();
                employeeName.selectAll();
                return;
            }

            int index = list.getSelectedIndex(); //get selected index
            if (index == -1) { //no selection, so insert at beginning
                index = 0;
            } else {           //add after the selected item
                index++;
            }
            //The following tracks the validity of the symbols.
            String symbolResult = sf.checkInputSymbol(name);

             //warn user when the symbol is invalid
             if(symbolResult.equals("bad")){
            listModel.insertElementAt(employeeName.getText()+" *Invalid symbol. Please remove.", index);
              }
            //keep the valid symbol
            if(symbolResult.equals("good")){
            listModel.insertElementAt(employeeName.getText(), index);
            }
            //If we just wanted to add to the end, we'd do this:
            //listModel.addElement(employeeName.getText());

            //Reset the text field.
            employeeName.requestFocusInWindow();
            employeeName.setText("");

            //Select the new item and make it visible.
            list.setSelectedIndex(index);
            list.ensureIndexIsVisible(index);
        }

        //This method tests for string equality. You could certainly
        //get more sophisticated about the algorithm.  For example,
        //you might want to ignore white space and capitalization.
        protected boolean alreadyInList(String name) {
            return listModel.contains(name);
        }

        //Required by DocumentListener.
        public void insertUpdate(DocumentEvent e) {
            enableButton();
        }

        //Required by DocumentListener.
        public void removeUpdate(DocumentEvent e) {
            handleEmptyTextField(e);
        }

        //Required by DocumentListener.
        public void changedUpdate(DocumentEvent e) {
            if (!handleEmptyTextField(e)) {
                enableButton();
            }
        }

        private void enableButton() {
            if (!alreadyEnabled) {
                button.setEnabled(true);
            }
        }

        private boolean handleEmptyTextField(DocumentEvent e) {
            if (e.getDocument().getLength() <= 0) {
                button.setEnabled(false);
                alreadyEnabled = false;
                return true;
            }
            return false;
        }
    }

    //This method is required by ListSelectionListener.
    public void valueChanged(ListSelectionEvent e) {
        if (!e.getValueIsAdjusting()) {

            if (list.getSelectedIndex() == -1) {
            //No selection, disable fire button.
                removeButton.setEnabled(false);

            } else {
            //Selection, enable the fire button.
                removeButton.setEnabled(true);
            }
        }
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
public void createAndShowGUI() {
        //Make sure we have nice window decorations.
        JFrame.setDefaultLookAndFeelDecorated(true);

        //Create and set up the window.
       frame = new JDialog(sf,true);

       frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        JComponent newContentPane = new ListDemo();
        newContentPane.setOpaque(true); //content panes must be opaque
        frame.setContentPane(newContentPane);

        //Display the window.
        frame.setLocation(400,100);
        frame.pack();
        frame.setVisible(true);
    }


}

